function gadget:GetInfo()
   return {
      name         = "Trees Spawner",
      desc         = "Places trees",
      author       = "Doo",
      date         = "26/04/2016",
      license      = "GPL 2.0 or later", -- should be compatible with Spring
      layer        = 0,
      enabled      = true,
   }
end


if (gadgetHandler:IsSyncedCode()) then  --Sync
	local minTreeHeight = 10
	local maxTreeHeight = 250
	local snowMap = false
	local minDistance = 16
	local density = 1/24	
	
	function gadget:Initialize()
		-- get all replacement trees
		local replacementTrees = {}
		local count = 0
		for featureDefID, featureDef in pairs(FeatureDefs) do
			if string.find(featureDef.name, "lowpoly_tree_") then
				if snowMap then
					if string.find(featureDef.name, "lowpoly_tree_snowy") then
						count = count + 1
						replacementTrees[count] = featureDefID
					end
				else
					if not string.find(featureDef.name, "lowpoly_tree_snowy") then
						count = count + 1
						replacementTrees[count] = featureDefID
					end
				end
			end
		end
		
		-- Get Random positions
		local ctTrees = 0
		local trees = {}
		local invDensity = 1/density
		for x = 0,Game.mapSizeX/2, minDistance do
			for z = 0,Game.mapSizeZ, minDistance do
				local y = Spring.GetGroundHeight(x,z)
				if y > minTreeHeight and y < maxTreeHeight and math.random(1,invDensity) == 1 and Spring.TestMoveOrder(UnitDefNames.armstump.id, x, y, z) == true then
					ctTrees = ctTrees + 1
					trees[ctTrees] = {x = x, y = y, z = z}
					ctTrees = ctTrees + 1
					trees[ctTrees] = {x = Game.mapSizeX - x, y = y, z = Game.mapSizeZ - z}	
				end
			end
		end				
		
		for tree, pos in pairs(trees) do
			Spring.CreateFeature(replacementTrees[math.random(1,count)],(pos.x),(pos.y),(pos.z), math.random(0,360)*math.pi*2/360)
		end
	end
end





